/*
Thirteen Spikes Unlimited version 0.2.0
Copyright (c) 2008 Blazing Games Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.tsu
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;

	public class About
	extends Sprite
	{
// ***** CONSTANTS **********************************************************

		public static const PAGE1_TEXT:String = 
"This game was created for Blazing Games Inc. by Billy D. Spelchan "+
"(the person writing this).\n\n"+
"This game is the logical extension to my Thirteen Spikes Squared game. "+
"The 1.0 release of this game will not only allow you to play through "+
"multiple sets (campaigns) of levels, but will have a construction set to "+
"allow you to create your own campaigns and will have an unlimited mode that "+
"lets you go through a theoretically unlimited number of randomly generated "+
"levels to see how long you can last.";

		public static const PAGE2_TEXT:String = 
"This program is free software; you can redistribute it and/or modify "+
"it under the terms of the GNU General Public License as published by "+
"the Free Software Foundation; either version 2 of the License, or "+
"(at your option) any later version.\n\n"+
"This program is distributed in the hope that it will be useful, "+
"but WITHOUT ANY WARRANTY; without even the implied warranty of "+
"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the "+
"GNU General Public License for more details.\n\n"+
"You should have received a copy of the GNU General Public License "+
"along with this program; if not, write to the Free Software "+
"Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA";

// ***** VARIABLES **********************************************************

		protected var _tsu:ThirteenSpikesUnlimited;
		protected var _conButton:TextButton;
		protected var _about_text:TextField;
		protected var _page:int = 1;

// ***** CONSTRUCTOR ********************************************************

		public function About(tsu:ThirteenSpikesUnlimited)
		{
			_tsu = tsu;
			var format:TextFormat = new TextFormat(null, 42, 0xFFFF00, null, null, null, null, null, TextFormatAlign.CENTER);
			var formatAbout:TextFormat = new TextFormat(null, 18, 0xCCCC00);
			var about:TextField = new TextField();
			about.x = 0;
			about.y = 0;
			about.width = 640;
			about.height = 70;
			about.defaultTextFormat = format;
			about.text = "About Thirteen Spikes Unlimited";
			addChild(about);

			_about_text = new TextField();
			_about_text.x = 10;
			_about_text.y = 70;
			_about_text.width = 620;
			_about_text.height = 300;
			_about_text.wordWrap = true;
			_about_text.defaultTextFormat = formatAbout;
			_about_text.text = PAGE1_TEXT;
			addChild(_about_text);
			_conButton = new TextButton("Continue...");
			_conButton.x = 160;
			_conButton.y = 420;
			addChild(_conButton);
			_conButton.addEventListener(MouseEvent.MOUSE_DOWN, handleContinue);
		}

// ***** Functions - Event Handling *****************************************

		private function handleContinue(evt:Event):void
		{
			++_page;
			if (_page > 2) {
				_about_text.text = PAGE1_TEXT;
				_page = 1;
				_tsu.changeMode(ThirteenSpikesUnlimited.MODE_TITLE);
			} else {
				_about_text.text = PAGE2_TEXT;
			}
		}

	}
}
