/*
Thirteen Spikes Unlimited version 0.8.0
Copyright (c) 2008-2009 Blazing Games Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.tsu
{
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;

	import com.blazinggames.tsu.skins.Skin;

	public class Campaign
	extends Level
	{

// ***** CONSTANTS **********************************************************

		public var DEFAULT_CAMPAIGN:Array = new Array(
			new Array(1,1,1,1,1,1,1,1,1,1,1,1,1),
			new Array(0,0,0,0,2,2,2,2,2,0,0,0,0),
			new Array(0,0,2,2,2,0,0,0,2,2,2,0,0),
			new Array(0,2,0,2,0,2,0,2,0,2,0,2,0),
			new Array(0,2,4,2,0,2,4,2,0,2,4,2,0),
			new Array(0,4,8,4,0,4,8,4,0,4,8,4,0),
			new Array(8,4,0,4,8,12,14,12,8,4,0,4,8),
			new Array(0,0,4,4,6,2,2,6,6,4,4,0,0),
			new Array(4,2,0,2,4,2,4,6,4,6,4,6,8),
			new Array(0,4,8,8,4,0,4,8,12,16,16,12,8),
			new Array(8,6,10,14,12,12,14,12,10,6,4,6,8),
			new Array(8,4,12,0,16,0,8,12,0,8,16,16,4),
			new Array(18,6,2,0,18,6,10,8,18,6,14,12,0)
		);

// ***** VARIABLES **********************************************************

		protected var _campaign:Array;

// ***** CONSTRUCTOR ********************************************************

		public function Campaign(tsu:ThirteenSpikesUnlimited)
		{
			super(tsu);
			_campaign = DEFAULT_CAMPAIGN;
		}

// ***** Functions - Level Management ***************************************

		override public function generateLevel(deviation:int):void
		{
			var step:int = deviation - 1;
			if (step >= _campaign.length) {
				removeEventListener(MouseEvent.MOUSE_UP, handleMouseUp);
				_tsu.gameOver(_curLevel);
				return;
			}
			
			// build the level from the data
			for (var cntr:int = 0; cntr < NUM_SPIKES; ++cntr) {
				_platforms[cntr].y = LEVEL_MIDPOINT + STEP_SIZE * _campaign[step][cntr];
				_spikes[cntr].setStartingSpot(_platforms[cntr].y - LEVEL_MIDPOINT * 3);
			}

			// set the safe spot and balloon spot
			_safe = Math.random() * NUM_SPIKES;
			_spikes[_safe].setStartingSpot(_spikes[_safe].getStartingSpot() - Skin.PLAYER_HEIGHT);
			_bspot = Math.random() * NUM_SPIKES;
			_player.x = _platforms[_bspot].x + (Skin.PLATFORM_WIDTH - Skin.PLAYER_WIDTH)/2;
			_player.y = _platforms[_bspot].y - Skin.PLAYER_HEIGHT;
			_player.startTeleport();
			_playTime = 0;
			_endTime = Number(LEVEL_MIDPOINT) / Number(PIXELS_PER_SECOND) + 2 * MOVEMENT_START_DELAY;
			_playInProgress = true;
			addEventListener(MouseEvent.MOUSE_UP, handleMouseUp);
		}
		
		public function setCampaign(campaign:Array):void
		{
			_campaign = campaign;
		}
	}
}
