/*
Thirteen Spikes Unlimited version 0.4.0
Copyright (c) 2008-2009 Blazing Games Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.tsu
{
	import flash.display.Sprite;
	
	import com.blazinggames.tsu.skins.Skin;

	public class Platform
	extends Sprite
	{
// ***** CONSTANTS **********************************************************

		public static const PLATFORM_FILL_COLOR:int = 0x0099CC;

// ***** VARIABLES **********************************************************

		public var _fillColor:int = PLATFORM_FILL_COLOR;
		protected var _strip:ImageStrip;

// ***** CONSTRUCTOR ********************************************************

		public function Platform()
		{
			_strip = null;
			draw();
		}

// ***** Functions - Rendering **********************************************

		public function draw():void
		{
			graphics.clear();
			graphics.beginFill(_fillColor);
            graphics.drawRect(2, 0, Skin.PLATFORM_WIDTH - 4, Skin.PLATFORM_HEIGHT);
            graphics.endFill();
		}

		public function setImageStrip(ims:ImageStrip):void
		{
			if (_strip != null)
				removeChild(_strip);
			_strip = ims;
			if (ims == null) {
				draw();
			} else {
				graphics.clear();
				addChild(_strip);
			}
		}

		public function updateAnimation(delta:Number):void
		{
			if (_strip != null)
				_strip.updateAnimation(delta);
		}
	}
}
