/*
Thirteen Spikes Unlimited version 0.4.0
Copyright (c) 2008-2009 Blazing Games Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.tsu
{
	import flash.display.Sprite;

	import com.blazinggames.tsu.skins.Skin;

	public class Player
	extends Sprite
	{
// ***** CONSTANTS **********************************************************


// ***** VARIABLES **********************************************************

		protected var _strip:ImageStrip;
		protected var _appearStart:int;
		protected var _appearEnd:int;
		protected var _stationaryStart:int;
		protected var _stationaryEnd:int;
		protected var _popStart:int;
		protected var _popEnd:int;
		protected var _alive:Boolean;

// ***** CONSTRUCTOR ********************************************************

		public function Player()
		{
			_strip = null;
			_alive = true;
			draw();
		}

// ***** Functions - Rendering **********************************************

		public function draw():void
		{
			graphics.clear();
//			graphics.beginFill(0xCC00CC);
			graphics.beginGradientFill("radial", 
					new Array(0xFFFFFF, 0xCC00CC, 0x550055), new Array(1,1,1),
					new Array(0, 25, 255));
            graphics.drawEllipse(0, 0, Skin.PLAYER_WIDTH, Skin.PLAYER_HEIGHT);
            graphics.endFill();
		}
		
// ***** Functions - Getting and Setting ************************************

		public function startTeleport():void
		{
			_alive = true;
			if (_strip != null)
				_strip.setAnimation(_appearStart, _appearEnd, false);
		}
		
		public function startDeath():void
		{
			_alive = false;
			if (_strip != null)
				_strip.setAnimation(_popStart, _popEnd, false);
		}
		
		public function setImageStrip(ims:ImageStrip,
				appearStart:int = 0, appearEnd:int = 0,
				stationaryStart:int = 0, stationaryEnd:int = 0,
				popStart:int = 0, popEnd:int = 0):void
		{
			if (_strip != null)
				removeChild(_strip);
			_strip = ims;
			_appearStart = appearStart
			_appearEnd = appearEnd;
			_stationaryStart = stationaryStart;
			_stationaryEnd = stationaryEnd;
			_popStart = popStart;
			_popEnd = popEnd;
			
			if (ims == null) {
				draw();
			} else {
				graphics.clear();
				_strip.setAnimation(appearStart, appearEnd, false);
				addChild(_strip);
			}
		}

		public function updateAnimation(delta:Number):void
		{
			if (_strip == null)
				return;
			var animating:Boolean = _strip.updateAnimation(delta);
			if (( !animating) && (_alive))
				_strip.setAnimation(_stationaryStart, _stationaryEnd);
		}
	}
}
