/*
Thirteen Spikes Unlimited version 0.2.0
Copyright (c) 2008 Blazing Games Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.tsu
{
	import flash.display.Shape;
	import flash.display.SimpleButton;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;

	public class Score
	extends Sprite
	{
// ***** CONSTANTS **********************************************************

		public static const YOURLEVEL_TEXT:String = "You reached level ";
		public static const BESTLEVEL_TEXT:String = "Highest level ";
		private static const KEEPTRYING_TEXT:String = "Keep trying!";
		private static const TIE_TEXT:String = "You matched the high!";
		private static const NEWHIGH_TEXT:String = "New high achieved!";


// ***** VARIABLES **********************************************************

		protected var _tsu:ThirteenSpikesUnlimited;
		protected var _score_txt:TextField;
		protected var _high_txt:TextField;
		protected var _message_txt:TextField;
		protected var _conButton:TextButton;
		protected var _highestLevel:int;

// ***** CONSTRUCTOR ********************************************************

		public function Score(tsu:ThirteenSpikesUnlimited)
		{
			_tsu = tsu;
			_highestLevel = 0;
			
			var format:TextFormat = new TextFormat(null, 64, 0xFFFF00, null, null, null, null, null, TextFormatAlign.CENTER);
			_score_txt = new TextField();
			_score_txt.x = 0;
			_score_txt.y = 70;
			_score_txt.width = 640;
			_score_txt.height = 70;
			_score_txt.defaultTextFormat = format;
			addChild(_score_txt);
			_high_txt = new TextField();
			_high_txt.x = 0;
			_high_txt.y = 140;
			_high_txt.width = 640;
			_high_txt.height = 70;
			_high_txt.defaultTextFormat = format;
			addChild(_high_txt);
			_message_txt = new TextField();
			_message_txt.x = 0;
			_message_txt.y = 210;
			_message_txt.width = 640;
			_message_txt.height = 70;
			_message_txt.defaultTextFormat = format;
			addChild(_message_txt);
			setLastScore(1);

			_conButton = new TextButton("Continue...");
			_conButton.x = 160;
			_conButton.y = 320;
			addChild(_conButton);
			_conButton.addEventListener(MouseEvent.MOUSE_UP, handleTitle);

		}

// ***** Functions - Event Handling *****************************************

		private function handleTitle(evt:Event):void
		{
			_tsu.changeMode(ThirteenSpikesUnlimited.MODE_TITLE);
		}
		
// ***** Functions - Getting and Setting ************************************

		public function setLastScore(n:int):void
		{
			_score_txt.text = YOURLEVEL_TEXT + n;
			_high_txt.text = BESTLEVEL_TEXT + _highestLevel;
			if (n > _highestLevel) {
				_message_txt.text = NEWHIGH_TEXT;
				_highestLevel = n;
			} else if (n == _highestLevel)
				_message_txt.text = TIE_TEXT;
			else
				_message_txt.text = KEEPTRYING_TEXT;
		}
	}
}
