/*
Thirteen Spikes Unlimited version 0.4.0
Copyright (c) 2008-2009 Blazing Games Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.tsu
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;

	import com.blazinggames.tsu.skins.Skin;

	public class Spike
	extends Sprite
	{
// ***** CONSTANTS **********************************************************


// ***** VARIABLES **********************************************************

		public var _startingSpot:Number;

		protected var _strip:ImageStrip;
		
// ***** CONSTRUCTOR ********************************************************

		public function Spike()
		{
			_strip = null;
			draw();
		}

// ***** Functions - Rendering **********************************************

		public function draw():void
		{
			graphics.clear();
			graphics.beginFill(0x996633);
            graphics.drawRect(2, 2, Skin.SPIKE_WIDTH-4, Skin.SPIKE_HEIGHT-120);
            graphics.endFill();
			graphics.beginFill(0xCC9966);
			graphics.moveTo(2, Skin.SPIKE_HEIGHT-120);
			graphics.lineTo(Skin.SPIKE_WIDTH/2, Skin.SPIKE_HEIGHT)
			graphics.lineTo(Skin.SPIKE_WIDTH-4, Skin.SPIKE_HEIGHT-120);
			graphics.lineTo(Skin.SPIKE_WIDTH/4*3, Skin.SPIKE_HEIGHT-160);
			graphics.lineTo(Skin.SPIKE_WIDTH/2, Skin.SPIKE_HEIGHT-120);
			graphics.lineTo(Skin.SPIKE_WIDTH/4, Skin.SPIKE_HEIGHT-160);
            graphics.endFill();
			
		}
		
// ***** Functions - Getting and Setting ************************************

		public function setStartingSpot(spot:Number):void
		{
			_startingSpot = spot;
			y = spot;
		}
		
		public function getStartingSpot():Number
		{
			return _startingSpot;
		}
		
		public function setImageStrip(ims:ImageStrip):void
		{
			if (_strip != null)
				removeChild(_strip);
			_strip = ims;
			if (ims == null) {
				draw();
			} else {
				graphics.clear();
				addChild(_strip);
			}
		}

		public function updateAnimation(delta:Number):void
		{
			if (_strip != null)
				_strip.updateAnimation(delta);
		}
	}
}
