/*
Thirteen Spikes Unlimited version 0.8.0
Copyright (c) 2008 Blazing Games Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.tsu
{
	import flash.display.Shape;
	import flash.display.SimpleButton;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;

	public class TextButton
	extends SimpleButton
	{
// ***** CONSTANTS **********************************************************

		public static const DEFAULT_WIDTH:int = 320;
		public static const DEFAULT_HEIGHT:int = 50;
		public static const DEFAULT_FONTSIZE:int = 32;

// ***** VARIABLES **********************************************************

// ***** CONSTRUCTOR ********************************************************

		public function TextButton(s:String, w:int = DEFAULT_WIDTH, h:int = DEFAULT_HEIGHT, fontsize:int = DEFAULT_FONTSIZE)
		{
			var format:TextFormat = new TextFormat(null, fontsize, null, null, null, null, null, null, TextFormatAlign.CENTER);
			var tfUp:TextField = new TextField();
			tfUp.width = w;
			tfUp.height = h;
			tfUp.defaultTextFormat = format;
			tfUp.text = s;
			tfUp.textColor = 0xFFFFFF;
			tfUp.background = true;
			tfUp.backgroundColor = 0x000080;
			upState = tfUp;
			
			var tfOver:TextField = new TextField();
			tfOver.width = w;
			tfOver.height = h;
			tfOver.defaultTextFormat = format;
			tfOver.text = s;
			tfOver.textColor = 0xFF00FF;
			tfOver.background = true;
			tfOver.backgroundColor = 0x0000CC;
			overState = tfOver;
			
			var tfDown:TextField = new TextField();
			tfDown.width = w;
			tfDown.height = h;
			tfDown.defaultTextFormat = format;
			tfDown.text = s;
			tfDown.textColor = 0xFF0000;
			tfDown.background = true;
			tfDown.backgroundColor = 0x0000FF;
			downState = tfDown;
			
			var hitbox:Shape = new Shape();
            hitbox.graphics.beginFill(0xFFFFFF);
            hitbox.graphics.drawRect(0, 0, w, h);
            hitbox.graphics.endFill();
			hitTestState = hitbox;
		}

	}
}
