/*
Thirteen Spikes Unlimited version 0.8.0
Copyright (c) 2008-2009 Blazing Games Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.tsu
{
	import flash.display.Shape;
	import flash.display.SimpleButton;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;

	import com.blazinggames.tsu.skins.Skin;

	public class Title
	extends Sprite
	{
// ***** CONSTANTS **********************************************************

		public static const START_TEXT:String = "Play unlimited Game!";
		public static const START_CAMPAIGN:String = "Play Campaign";
		public static const ABOUT_TEXT:String = "About the Game!";
		public static const EDIT_TEXT:String = "Edit/play custom game";
		private static const COPYRIGHT_TXT:String = 
"Developed by Billy D. Spelchan. Copyright \xa9 2008-2009 Blazing Games Inc.";

// ***** VARIABLES **********************************************************

		protected var _tsu:ThirteenSpikesUnlimited;
		protected var _startButton:TextButton;
		protected var _campaignButton:TextButton;
		protected var _aboutButton:TextButton;
		protected var _editButton:TextButton;
		protected var _spikes:Array;

		protected var _speed:Number = 20;

// ***** CONSTRUCTOR ********************************************************

		public function Title(tsu:ThirteenSpikesUnlimited)
		{
			_tsu = tsu;
			_spikes = new Array();
			for (var cntr:int = 0; cntr < 13; ++cntr) {
				_spikes[cntr] = new Spike();
				_spikes[cntr].x = Skin.SPIKE_WIDTH * cntr - 5;
				_spikes[cntr].y = 0;
				addChild(_spikes[cntr]);
			}
			var format:TextFormat = new TextFormat(null, 64, 0xFFFF00, null, null, null, null, null, TextFormatAlign.CENTER);
			var thirteen:TextField = new TextField();
			thirteen.x = 0;
			thirteen.y = 0;
			thirteen.width = 640;
			thirteen.height = 70;
			thirteen.defaultTextFormat = format;
			thirteen.text = "Thirteen Spikes";
			addChild(thirteen);
/*
			var spikes:TextField = new TextField();
			spikes.x = 0;
			spikes.y = 70;
			spikes.width = 640;
			spikes.height = 70;
			spikes.defaultTextFormat = format;
			spikes.text = "Spikes";
			addChild(spikes);
*/
			var unlimited:TextField = new TextField();
			unlimited.x = 0;
			unlimited.y = 70;
			unlimited.width = 640;
			unlimited.height = 70;
			unlimited.defaultTextFormat = format;
			unlimited.text = "Unlimited";
			addChild(unlimited);

			var versionFormat:TextFormat = new TextFormat(null, 24, 0xFFFF00, null, null, null, null, null, TextFormatAlign.CENTER);
			var ver:TextField = new TextField();
			ver.x = 0;
			ver.y = 140;
			ver.width = 640;
			ver.height = 30;
			ver.defaultTextFormat = versionFormat;
			ver.text = "Version 0.8.0";
			addChild(ver);

			_startButton = new TextButton(START_TEXT);
			_startButton.x = 160;
			_startButton.y = 190;
			addChild(_startButton);
			_startButton.addEventListener(MouseEvent.MOUSE_UP, handleStart);

			_campaignButton = new TextButton(START_CAMPAIGN);
			_campaignButton.x = 160;
			_campaignButton.y = 250;
			addChild(_campaignButton);
			_campaignButton.addEventListener(MouseEvent.MOUSE_UP, handleCampaign);

			_aboutButton = new TextButton(ABOUT_TEXT);
			_aboutButton.x = 160;
			_aboutButton.y = 310;
			addChild(_aboutButton);
			_aboutButton.addEventListener(MouseEvent.MOUSE_UP, handleAbout);

			_editButton = new TextButton(EDIT_TEXT);
			_editButton.x = 160;
			_editButton.y = 370;
			addChild(_editButton);
			_editButton.addEventListener(MouseEvent.MOUSE_UP, handleEdit);

			var formatcr:TextFormat = new TextFormat(null, 15, 0xFFFFFF, null, null, null, null, null, TextFormatAlign.CENTER);
			var copyright:TextField = new TextField();
			copyright.x = 0;
			copyright.y = 460;
			copyright.width = 640;
			copyright.height = 20;
			copyright.defaultTextFormat = formatcr;
			copyright.wordWrap = true;
			copyright.text = COPYRIGHT_TXT;
			addChild(copyright);
		}

// ***** Functions - Event Handling *****************************************

		private function handleStart(evt:Event):void
		{
			_tsu.changeMode(ThirteenSpikesUnlimited.MODE_GAME);
		}

		private function handleCampaign(evt:Event):void
		{
			_tsu.changeMode(ThirteenSpikesUnlimited.MODE_CAMPAIGN);
		}

		private function handleAbout(evt:Event):void
		{
			_tsu.changeMode(ThirteenSpikesUnlimited.MODE_ABOUT);
		}

		private function handleEdit(evt:Event):void
		{
			_tsu.changeMode(ThirteenSpikesUnlimited.MODE_EDIT);
		}

		public function update(delta:Number):void
		{
			var ny:Number = _spikes[0].y + (delta * _speed);
			if (ny > 0) {
				ny = 0;
				_speed = -20;
			} else if (ny < -480) {
				ny = -480;
				_speed = 20;
			}
			
			for (var cntr:int = 0; cntr < 13; ++cntr)
				_spikes[cntr].y = ny;
		}
	}
}
