/*
Thirteen Spikes Unlimited version 0.4.0
Copyright (c) 2008-2009 Blazing Games Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.tsu.skins
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
	import 	flash.events.*;
	import flash.net.URLRequest;

	import com.blazinggames.tsu.ImageStrip;

	public class Skin extends EventDispatcher
	{
// ***** CONSTANTS **********************************************************

		public static const SKIN_LOADED:String = "Skin Loaded";
		public static const BACKDROP_WIDTH:int = 640;
		public static const BACKDROP_HEIGHT:int = 480;
		
		public static const PLAYER_WIDTH:int = 32;
		public static const PLAYER_HEIGHT:int = 32;

		public static const PLATFORM_WIDTH:int = 50;
		public static const PLATFORM_HEIGHT:int = 480;

		public static const SPIKE_WIDTH:int = 50;
		public static const SPIKE_HEIGHT:int = 480;

		public static const FRAMEINDEX_PLATFORM_START:int = 0;
		public static const FRAMEINDEX_PLATFORM_END:int = 1;
		public static const FRAMEINDEX_SPIKE_START:int = 2;
		public static const FRAMEINDEX_SPIKE_END:int = 3;
		public static const FRAMEINDEX_BALLOON_APPEAR_START:int = 4;
		public static const FRAMEINDEX_BALLOON_APPEAR_END:int = 5;
		public static const FRAMEINDEX_BALLOON_STATIONARY_START:int = 6;
		public static const FRAMEINDEX_BALLOON_STATIONARY_END:int = 7;
		public static const FRAMEINDEX_BALLOON_POP_START:int = 8;
		public static const FRAMEINDEX_BALLOON_POP_END:int = 9;

// ***** VARIABLES **********************************************************

		public var _backdropBitmap:Bitmap;
		public var _backdropColor:uint;
		
// ***** CONSTRUCTOR ********************************************************

		public function Skin(backdropColor:uint = 0x000080)
		{
			_backdropColor = backdropColor;
		}

		public function loadSkin():void
		{
			var bd:BitmapData = new BitmapData(BACKDROP_WIDTH, BACKDROP_HEIGHT, false, _backdropColor);
			_backdropBitmap = new Bitmap(bd);
			var evnt:Event = new Event(SKIN_LOADED);
			dispatchEvent(evnt); 
		}
		

// ***** Functions - Getting and Setting ************************************

		public function getBackdrop():Bitmap
		{
			return _backdropBitmap;
		}

		public function getFrameIndex(frameID:int):int
		{
			return 0;
		}

		public function createSpikeStrip():ImageStrip
		{
			return null;
		}

		public function createPlatformStrip():ImageStrip
		{
			return null;
		}
		
		public function createPlayerStrip():ImageStrip
		{
			return null;
		}
	}
}
