/*
Thirteen Spikes Unlimited version 0.4.0
Copyright (c) 2008-2009 Blazing Games Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.tsu.skins.skyskin
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
	import 	flash.events.*;
	import flash.net.URLRequest;

	import com.blazinggames.tsu.ImageStrip;
	import com.blazinggames.tsu.skins.Skin;

	public class SkySkin extends Skin
	{
// ***** CONSTANTS **********************************************************

		private static const FRAME_INFO:Array = new Array(0,4,0,4,0,2,3,7,8,12);

// ***** VARIABLES **********************************************************

		[Embed(source="sky_background.jpg")]
		private var BackdropImage:Class;

		[Embed(source="sky_spike.gif")]
		private var SpikeImage:Class;
		private var _spikeBitmap:Bitmap;

		[Embed(source="sky_platform.gif")]
		private var PlatformImage:Class;
		private var _platformBitmap:Bitmap;

		[Embed(source="sky_balloon.gif")]
		private var PlayerImage:Class;
		private var _playerBitmap:Bitmap;

// ***** CONSTRUCTOR ********************************************************

		public function SkySkin()
		{
		}

		override public function loadSkin():void
		{
			_backdropBitmap = Bitmap(new BackdropImage());
			_spikeBitmap = Bitmap(new SpikeImage());
			_platformBitmap = Bitmap(new PlatformImage());
			_playerBitmap = Bitmap(new PlayerImage());
			
			var evnt:Event = new Event(SKIN_LOADED);
			dispatchEvent(evnt); 
		}


// ***** Functions - Getting and Setting ************************************

		override public function getBackdrop():Bitmap
		{
			return _backdropBitmap;
		}

		override public function getFrameIndex(frameID:int):int
		{
			return FRAME_INFO[frameID];
		}

		override public function createSpikeStrip():ImageStrip
		{
			return new ImageStrip(_spikeBitmap.bitmapData, 
					Skin.SPIKE_WIDTH, Skin.SPIKE_HEIGHT,
					true,5,.2);
		}

		override public function createPlatformStrip():ImageStrip
		{
			return new ImageStrip(_platformBitmap.bitmapData, 
					Skin.PLATFORM_WIDTH, Skin.PLATFORM_HEIGHT,
					true, 5, .1);
		}

		override public function createPlayerStrip():ImageStrip
		{
			return new ImageStrip(_playerBitmap.bitmapData, Skin.PLAYER_WIDTH, Skin.PLAYER_HEIGHT);
		}

	}
}
